/***************************************************************************
 *                                                                         *
 *   copyright (C) 2004 by Michael Buesch                                  *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#include "globalstuff.h"
#include "configuration.h"
#include "randomizer.h"
#include "pwmanagerdcopif.h"

#include <kapplication.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <dcopclient.h>


DCOPClient *dcopClient;
/** global DCOP-interface object */
PwManagerDCOPif *pwmDCOPinterface;

void no_keycard_support_msg_box(QWidget *parentWidget)
{
	KMessageBox::error(parentWidget,
			   i18n("No Chipcard-support available!\n"
				"If you want to use a chipcard, "
				"you have to compile PwM with the "
				"configure option --enable-keycard ."),
			   i18n("No Chipcard-support"));
}

void earlyGlobalInit()
{
	dcopClient = kapp->dcopClient();
	dcopClient->setNotifications(true);
	Configuration::init();
	Randomizer::init();
}

void lateGlobalCleanup()
{
	Randomizer::cleanup();
	Configuration::cleanup();
}
