/***************************************************************************
 *                                                                         *
 *   copyright (C) 2003, 2004 by Michael Buesch                            *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#ifndef GLOBALSTUFF_H
#define GLOBALSTUFF_H

#include "config.h"
#include "compiler.h"

#include <string>
#include <sstream>

class PwManagerDCOPif;
class QWidget;
class DCOPClient;

extern void earlyGlobalInit();
extern void lateGlobalCleanup();

extern PwManagerDCOPif *pwmDCOPinterface;
extern void no_keycard_support_msg_box(QWidget *parentWidget);
extern DCOPClient *dcopClient;

#ifdef PROG_NAME
# undef PROG_NAME
#endif
#define PROG_NAME	"PwManager"

#ifdef CONFIG_DEBUG
# define PWM_DEBUG
#else
# undef PWM_DEBUG
#endif

#ifdef QT_MAKE_VERSION
# undef QT_MAKE_VERSION
#endif
#define QT_MAKE_VERSION(a,b,c)	(((a) << 16) | ((b) << 8) | (c))

/** remove "unused parameter" warnings */
#ifdef PARAM_UNUSED
# undef PARAM_UNUSED
#endif
#define PARAM_UNUSED(x)	(void)x

/** return the number of elements in an array */
#ifdef array_size
# undef array_size
#endif
#define array_size(x)	(sizeof(x) / sizeof((x)[0]))

/** convert something to string using ostringstream */
template <class T> inline
std::string tostr(const T &t)
{
	std::ostringstream s;
	s << t;
	return s.str();
}

/** delete the memory and NULL the pointer */
template<class T> inline
void delete_and_null(T *&p)
{
	delete p;
	p = 0;
}
/** delete the memory if the pointer isn't a NULL pointer */
template<class T> inline
void delete_ifnot_null(T *&p)
{
	if (p)
		delete_and_null(p);
}

template<class T> inline
void delete_and_null_array(T *&p)
{
	delete [] p;
	p = 0;
}

template<class T> inline
void delete_ifnot_null_array(T *&p)
{
	if (p)
		delete_and_null_array(p);
}

#endif // GLOBALSTUFF_H
