/***************************************************************************
 *                                                                         *
 *   copyright (C) 2003, 2004 by Michael Buesch                            *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#include "pwmexception.h"

#include <klocale.h>
#include <kmessagebox.h>


PwMException::PwMException(exceptionId id, const char *message)
{
	exId = id;
	exMess = message;
}

void pwmFatal(const char *id,
	      const char *file,
	      int line)
{
	cerr << PROG_NAME " " << id << " at "
	     << file << ":" << line
	     << endl;
}

void PwMException::printError(const string &msg)
{
	QString __msg(i18n("PwManager generated a fatal fault:\n"));
	__msg += msg.c_str();
	cerr << "\n\n" << __msg.latin1() << endl;
	KMessageBox::error(0, __msg, i18n("PwManager fatal ERROR!"));
}

void PwMException::printInfo(const string &msg)
{
	cout << "PwManager INFO: " << msg << endl;
}

void PwMException::printWarn(const string &msg)
{
	cerr << "PwManager WARNING: " << msg << endl;
}
