/***************************************************************************
 *                                                                         *
 *   copyright (C) 2004 by Michael Buesch                                  *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#ifndef SELFTEST_H
#define SELFTEST_H

#include <qthread.h>
#include <qtimer.h>
#include <qobject.h>
#include "pwmexception.h"

#include <string>

// timeout in seconds
#define SCHEDULE_TIMEOUT	3

using std::string;

/* internal wrapper to workaround MOC issues */
class __SelfTest : public QThread
		 , public QObject
{
public:
	__SelfTest() {}
};

/** PwManager algorithm selftest */
class SelfTest : public __SelfTest
{
	Q_OBJECT
public:
	SelfTest();
	~SelfTest();

	/** schedule a testrun */
	void schedule()
		{
			QTimer::singleShot(SCHEDULE_TIMEOUT * 1000, this,
					   SLOT(doSelfTest()));
		}

protected slots:
	void doSelfTest()
			{ start(); }
	/** thread communication slot */
	void comm_slot(const string *line);

protected:
	/** print the "failed" message and exit the app */
	void failed(const char *algo);
	/** worker thread */
	void run();
};

#endif
