/***************************************************************************
 *                                                                         *
 *   copyright (C) 2003 by Michael Buesch                                  *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#ifndef SETMASTERPWWNDIMPL_H
#define SETMASTERPWWNDIMPL_H

#include "setmasterpwwnd.h"

#include <klocale.h>

#include <stdint.h>
#include <string>
using std::string;

class PwMKeyCard;

/** set master pw wnd */
class SetMasterPwWndImpl : public setMasterPwWnd
{
	Q_OBJECT
public:
	SetMasterPwWndImpl(QWidget* parent = 0, const char *name = 0);
	~SetMasterPwWndImpl();

	static QString string_cardNone()
			{ return i18n("NONE"); }

	/** returns the selected pw (or the key on the card) */
	string getPw(bool *useCard);
	/** set pointer to the keycard-access object */
	void setPwMKeyCard(PwMKeyCard *_keyCard)
			{ keyCard = _keyCard; }

public slots:
	/** ok button pressed */
	void okButton_slot();
	/** cancel button pressed */
	void cancelButton_slot();
	/** "generate a new card" button pressed */
	void genCardButton_slot();
	/** "select current card" button pressed */
	void selCardButton_slot();

protected slots:
	/** key from PwMKeyCard is available */
	void keyAvailable_slot(uint32_t cardId, const string &key);

protected:
	/** key of currently inserted card */
	string curCardKey;
	/** pointer to the keycard-access object */
	PwMKeyCard *keyCard;
};

#endif
