/***************************************************************************
 *                                                                         *
 *   copyright (C) 2003, 2004 by Michael Buesch                            *
 *   email: mbuesch@freenet.de                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License version 2        *
 *   as published by the Free Software Foundation.                         *
 *                                                                         *
 ***************************************************************************/

#ifndef SPINFORSIGNAL_H
#define SPINFORSIGNAL_H

#include <qobject.h>

#include <stdint.h>
#include <string>
using std::string;

/** non-ui-blocking spin for a QT-signal */
class SpinForSignal : public QObject
{
	Q_OBJECT
public:
	SpinForSignal();
	~SpinForSignal() {}

	/** do spin for signal */
	void spin(uint32_t *u32, string *str);
	/** cancel spinning */
	void cancelSpin();

public slots:
	void u32_str_slot(uint32_t u32, const string &str);

protected:
	volatile bool doSpin;
	uint32_t u32_storage;
	string str_storage;

protected:
	inline void spinSleep();
	void _spin();
};

#endif
